procedure mirsi_patsubr(input,c1,c2)
file input  {prompt = "Input image template or list"}
int c1 {prompt = "input minimum column for median calculation"}
int c2 {prompt = "input maximum column for median calculation"}
struct *inimglist
struct *rlist

begin

 int channel
 int index,ist,iend ,Tticks,waitticks,FowlerN,readmode,chksumval
 string inimg,s1,rfile,outimg

 inimg = input
 if(access("imgets.log")) 
    delete("imgets.log",verify-)
 if(substr(inimg,1,1) == "@") {  #input is a list, not a single image
   i = strlen(inimg)
   inimglist = substr(inimg,2,i)
 }
 else {
   if(access("list_in"))         #delete old copy of template f
     delete("list_in",verify-)
   files(inimg, > "list_in")     #expand file template into a l
   inimglist  = "list_in"
 }

 delete("tempim*.fits",verify-)
 delete("list_in2", verify-)
 delete("tmp_mos.fits",verify-)
 while(fscan(inimglist,inimg) != EOF) {

  print("Now processing ",inimg)
  outimg=substr(inimg,1,strlen(inimg)-5)//"p.fits"
  for (i=1; i<17; i=i+1)
  {
    ist=(i-1)*20+1
    iend=ist+19
    imcopy(inimg//"["//ist//":"//iend//",1:240]", "tempim"//i)
  }
  files("tempim"//c1, >"list_in2")
  delete("tmp_mos*",verify-)
  if (c1==c2)
  {
     imcopy("tempim"//c1, "tmp_mos")
  } else {
     for(i=c1+1;i<c2+1; i=i+1)
        files("tempim"//i, >> "list_in2")

     if (c2-c1<2)
        imcombine("@list_in2","tmp_mos",combine="average",nhi=0,nlow=0)
     else if (c2-c1==2)
        imcombine("@list_in2","tmp_mos",combine="median",reject="none",nhi=0,nlow=0)
     else
        imcombine("@list_in2","tmp_mos",combine="median",reject="sigclip",nkeep=3,nhi=0,nlow=0)
  }
  imcopy(inimg//"[1:320,1:240]",outimg)
  for (i=1; i<17; i=i+1)
  {
    ist=(i-1)*20+1
    iend=ist+19
    imarith("tempim"//i,"-","tmp_mos","tempim"//i)
    imcopy("tempim"//i//"[1:20,1:240]", outimg//"["//ist//":"//iend//",1:240]")
  }
  delete("tempim*",verify-)
 delete("list_in2",verify-)

 }
 delete("list_in*",verify-)
end

